//
//  CommandLineInterface.h
//  LevelSetMethod2
//
//  Created by kumada on 2012/12/18.
//  Copyright (c) 2012年 kumada. All rights reserved.
//

#ifndef LevelSetMethod2_CommandLineInterface_h
#define LevelSetMethod2_CommandLineInterface_h

#include <memory>
#include <boost/program_options.hpp>

namespace lsm
{
        class LevelSetMethodViewer2d;
        class LevelSetMethodViewer3d;
        class Parameters;
        
        /// class that implements command-line interfaces
        class CommandLineInterface
        {
        private:
                static std::unique_ptr<LevelSetMethodViewer2d> viewer2d_;
                static void display_2d();
                static void keyboard_2d(unsigned char key, int x, int y);
        
                static std::unique_ptr<LevelSetMethodViewer3d> viewer3d_;
                static void display_3d();
                static void keyboard_3d(unsigned char key, int x, int y);
                
                static void execute_level_set_method_in_2d(
                        int                                          argc,
                        char*                                        argv[],
                        const boost::program_options::variables_map& vm,
                        const Parameters&                            params
                );
                
                static void execute_level_set_method_in_3d(
                        int                                          argc,
                        char*                                        argv[],
                        const boost::program_options::variables_map& vm,
                        const Parameters&                            params
                );
                
        public:
                static void execute_level_set_method(int argc, char* argv[]);
        }; // class CommandLineInterface

} // namespace lsm

#endif // LevelSetMethod2_CommandLineInterface_h
