//
//  main.cpp
//  LevelSetMethod2
//
//  Created by kumada on 2012/11/15.
//  Copyright (c) 2012年 kumada. All rights reserved.
//

#if(UNIT_TEST)
#define BOOST_TEST_MAIN
#define BOOST_TEST_DYN_LINK

#include <boost/test/unit_test.hpp>

BOOST_AUTO_TEST_CASE(TEST_main)
{
        std::cout << "main\n";
}

#else // UNIT_TEST

#include "CommandLineInterface.h"
#include <boost/program_options.hpp>

namespace program_options = boost::program_options;

int main(int argc, char * argv[])
{
        try {
                lsm::CommandLineInterface::execute_level_set_method(argc, argv);
        }
        catch (const program_options::unknown_option& error) {
                std::cout << "<<unknown_option>> " << error.what() << std::endl;
        }
        catch (const program_options::invalid_option_value& error) {
                std::cout << "<<invalid_option_value>> " << error.what() << std::endl;
        }
        catch (const std::ios_base::failure& error) {
                std::cout << "<<ios_base::failure>> " << error.what() << std::endl;
        }
        catch (const std::runtime_error& error) {
                std::cout << "<<runtime_error>> " << error.what() << std::endl;
        }
        return 0;
}
#endif // UNIT_TEST
